package org.apache.maven;

/* ====================================================================
 * The Apache Software License, Version 1.1
 *
 * Copyright (c) 2003 The Apache Software Foundation.  All rights
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *       "This product includes software developed by the
 *        Apache Software Foundation (http://www.apache.org/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "Apache" and "Apache Software Foundation" and
 *    "Apache Maven" must not be used to endorse or promote products
 *    derived from this software without prior written permission. For
 *    written permission, please contact apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache",
 *    "Apache Maven", nor may "Apache" appear in their name, without
 *    prior written permission of the Apache Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Apache Software Foundation.  For more
 * information on the Apache Software Foundation, please see
 * <http://www.apache.org/>.
 *
 * ====================================================================
 */

import java.util.List;

import org.dom4j.Attribute;
import org.dom4j.Node;
import org.dom4j.tree.DefaultElement;

/**
 * @author <a href="bwalding@jakarta.org">Ben Walding</a>
 * @version $Id: NavBean.java,v 1.6 2003/07/17 10:44:05 bwalding Exp $
 */
public class NavBean
{
    private String location;
    private Node document;

    public void setDocument(Object o)
    {
        document = (Node) o;
    }

    private static String getAttribute(DefaultElement elem, String attribute, String defaultValue)
    {
        Attribute attr = elem.attribute(attribute);
        if (attr == null)
        {
            return defaultValue;
        }

        return attr.getStringValue();
    }

    private static boolean getCollapseAttribute(DefaultElement elem)
    {
        return Boolean.valueOf(getAttribute(elem, "collapse", "false")).booleanValue();
    }
    private static String getHREFAttribute(DefaultElement elem)
    {
        return getAttribute(elem, "href", null);
    }
    
    /**
     * Determines if the given node is collapsed.  If a parent of this node is
     * collapsed, this will give spurious results.
     * @param o
     * @return boolean
     */
    public boolean isCollapsed(Object o)
    {
        //If we don't know where we are, collapse it - something outside of our knowledge
        if (location == null)
        {
            return true;
        }

        if (!(o instanceof DefaultElement))
        {
            System.out.println(o.getClass().getName());
            return false;
        }
        DefaultElement elem = (DefaultElement) o;

        boolean collapsed = getCollapseAttribute(elem);
        if (!collapsed) 
        {
            return false;
        }

        if (isSelected(o))
        {
            return false;
        }

        //System.out.println(elem.asXML());
        String xpath;
        if (location.startsWith("/")  || location.startsWith(".")) {
            xpath =    ".//item[@href='" + location + "']";

        } else {
            xpath =   ".//item[@href='/" + location + "']";

        }

        
        List l = elem.selectNodes(xpath);

        if (l.size() != 0)
        {
            return false;
        }

        return true;
    }

    /**
     * Determines if a given <code>item</code> node is the selected node
     * @param o
     * @return boolean
     */
    public boolean isSelected(Object o)
    {
        if (location == null)
        {
            return false;
        }

        DefaultElement elem = (DefaultElement) o;
        if (location.equals(getHREFAttribute(elem)))
        {
            return true;
        }

        return false;
    }

    /**
     * Sets the location.
     * @param location The location to set
     */
    public void setLocation(String location)
    {
        if (!location.startsWith("/"))
            location = "/" + location;
            
        this.location = location;
    }

    /**
     * Find the first <code>item</code> with a given href
     * @param href
     * @return DefaultElement
     */
    public DefaultElement getFirstNodeByHREF(String href)
    {
        String xpath = "//item[@href='" + href + "']";
        return (DefaultElement) document.selectSingleNode(xpath);
    }
}
